## Generating Markdown

Occasionally you may want to generate markdown programmatically. For
example, the [supported PHP INI settings
table](/hhvm/configuration/INI-settings#supported-php-ini-settings) is
autogenerated.

1. Define a `BuildStep` for the data you want to generate the markdown
   from. See
   [PHPIniSupportInHHVMBuildStep](https://github.com/hhvm/user-documentation/blob/main/src/build/PHPIniSupportInHHVMBuildStep.php)
   for an example.

2. Define a `BuildStep` that writes markdown to the
   guides-generated-markdown/ directory, [defined
   here](https://github.com/hhvm/user-documentation/blob/9fd2aaeb60a236072ef99735a9114ec54d96da2c/src/build/BuildPaths.php#L49). See
   [PHPIniSupportInHHVMMarkdownBuildStep](https://github.com/hhvm/user-documentation/blob/main/src/build/PHPIniSupportInHHVMMarkdownBuildStep.php)
   for an example.

3. Add a symlink
   ([example](https://github.com/hhvm/user-documentation/blob/main/guides/hhvm/04-configuration/guides-generated-markdown))
   to the guide folder where you want to include this content.

4. Use `@@` syntax to include the generated file on the relevant page
   of your guide.

   ```
   @@ guides-generated-markdown/your_generated_file.md @@
   ```

5. Add a test ([example](https://github.com/hhvm/user-documentation/blob/9fd2aaeb60a236072ef99735a9114ec54d96da2c/tests/GuidePagesTest.php#L84)).

## API Example Code

Adding a `.md` file to the correct subdirectory in
[`api-examples`](https://github.com/hhvm/user-documentation/tree/main/api-examples)
will cause the build script to add its content to the respective API page.

The `.md` file may contain any combination of explanatory text and any number of
code examples following the same rules as above.
